StayUnsheathed = LibStub("AceAddon-3.0"):NewAddon("TimerTest", "AceTimer-3.0", "AceConsole-3.0")

function StayUnsheathed:OnInitialize()  
  local defaults = {
    char = {
      EnabledState = true,
      Primary = true,
      Secondary = true
    }
  }

  StayUnsheathed.db = LibStub("AceDB-3.0"):New("StayUnsheathedDB", defaults)

  StayUnsheathed:RegisterChatCommand("stayunsheathed","slashfunc")
  StayUnsheathed:RegisterChatCommand("su","slashfunc")
  print("StayUnsheathed 0.4 Loaded!")
end

function StayUnsheathed:slashfunc(input)
	if input == "" or input == "help" then
	  print("StayUnsheathed options menu.")
	  print("Avaliable options")
	  print("/su Enable (Enables the addon).")
          print("/su Disable (Disables the addon)") 
	  print("/su Primary (Disables/Enables the addon in your primary spec.)")
	  print("/su Secondary (Disables/Enables the addon in your secondary spec.)")
	  print("/su info (Prints current settings)")
	  print("StayUnsheathed is: " .. trueFalseToEnabledDisabled(StayUnsheathed.db.char.EnabledState))
	  print("Primary spec is: " .. trueFalseToEnabledDisabled(getPrimaryState()))
	  print("Secondary spec is: " .. trueFalseToEnabledDisabled(getSecondaryState()))
end

	if input == "enable" then
	  enableStayUnsheathed()
	end
	
	if input == "disable" then
	  disableStayUnsheathed()
	end
	
	if input == "primary" then
	  togglePrimary()
	end

	if input == "secondary" then
	  toggleSecondary()
	end
	
	if input == "info" then
	  print("StayUnsheathed is: " .. trueFalseToEnabledDisabled(StayUnsheathed.db.char.EnabledState))
	  print("Primary spec is: " .. trueFalseToEnabledDisabled(getPrimaryState()))
	  print("Secondary spec is: " .. trueFalseToEnabledDisabled(getSecondaryState()))
	end
end

function getPrimaryState()
	return StayUnsheathed.db.char.Primary
end

function getSecondaryState()
	return StayUnsheathed.db.char.Secondary
end

function togglePrimary()
	if StayUnsheathed.db.char.Primary then
	  StayUnsheathed.db.char.Primary = false
	else
	  StayUnsheathed.db.char.Primary = true
	end
	print("Primary spec is now " .. trueFalseToEnabledDisabled(StayUnsheathed.db.char.Primary))
end

function toggleSecondary()
	if StayUnsheathed.db.char.Secondary then
	  StayUnsheathed.db.char.Secondary = false
	else
	  StayUnsheathed.db.char.Secondary = true
	end
	print("Secondary spec is now " .. trueFalseToEnabledDisabled(StayUnsheathed.db.char.Secondary))
end

function toggleEnable()
  if isEnabled() then
    disableStayUnsheathed()
  else
    enableStayUnsheathed()
  end
end

function enableStayUnsheathed()
  StayUnsheathed.db.char.EnabledState = true
  startTimer()
  print("StayUnsheathed is now Enabled.")
end

function disableStayUnsheathed()
  StayUnsheathed.db.char.EnabledState = false
  StayUnsheathed:CancelTimer("TimerFeedback", true)
  print("StayUnsheathed is now Disabled")
end

function trueFalseToEnabledDisabled(bool)
   if bool then return "Enabled" else return "Disabled" end
end

function isEnabled()
  return StayUnsheathed.db.char.EnabledState 
end

function StayUnsheathed:OnEnable()
  startTimer()  
end

function startTimer()
  ToggleSheath()
  StayUnsheathed.Timer = StayUnsheathed:ScheduleRepeatingTimer("TimerFeedback", 3)  
end

function StayUnsheathed:TimerFeedback()
  result = GetSheathState()
  if result == 1 and isEnabled() and isSpecEnabled() then
	ToggleSheath()
  end
end

function isSpecEnabled()
  if GetActiveSpecGroup() == 1 then
	return StayUnsheathed.db.char.Primary
  end
  if GetActiveSpecGroup() == 2 then
	return StayUnsheathed.db.char.Secondary
  end
end